#!/usr/bin/env python
#
# Problem EPage 411
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np

from goldSearch import bracket, search

def f(a):
    a2 = a**2
    a4 = a**4 
    return ( a + 2./a2 )**2 - 4/a4

xStart = 0.1
h = 0.01 
x1, x2 = bracket(f,xStart,h)
x, fMin = search(f,x1,x2)
print "x= ", x 
print "f(x)= ", fMin

if False: 
    xs = np.linspace( 0.5, 1.5, 100 ) 
    fs = [ f(_) for _ in xs ]
    import pylab
    pylab.plot( xs, fs )
    pylab.xlabel('x')
    pylab.ylabel('f')
    pylab.grid('on')
    pylab.show()

    
