#!/usr/bin/env python
#
# Problem EPage 411
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np

from goldSearch import bracket, search

def f(x):
    return ( x - 1. )**2 + ( x**2 - 2. )**2 

xStart = 0.1
h = 0.01 
x1, x2 = bracket(f,xStart,h)
x, fMin = search(f,x1,x2)
print "x= ", x 
print "y=x^2= ", x**2 
print "f(x)= ", fMin

if False: 
    xs = np.linspace( 0.0, 2.5, 100 ) 
    fs = [ f(_) for _ in xs ]
    import pylab
    pylab.plot( xs, fs )
    pylab.xlabel('x')
    pylab.ylabel('f')
    pylab.grid('on')
    pylab.show()

    
