#!/usr/bin/env python
#
# Problem EPage 62
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, dot, prod, diag, transpose 

from LUdecomp import LUdecomp, LUsolve

A_orig = asarray( [ [ 4, -2, -3 ], [ 12, 4, -10 ], [ -16, 28, 18 ] ], dtype=float ) 
A = A_orig.copy() 
b_orig = asarray( [ 1.1, 0, -2.3 ], dtype=float ) 
b = b_orig.copy()

# Factor and solve our system:
# 
LUdecomp(A)
LUsolve(A,b)
print "Solution= ", b
assert np.linalg.norm( dot(A_orig,b) - b_orig ) < 1.e-6

