#!/usr/bin/env python
#
# Problem EPage 62
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, dot, sqrt

from gaussPivot import gaussPivot

A_orig = asarray( [ [ -1,  1, -1/sqrt(2),  0,          0, 0 ], 
                    [  0,  0,  1/sqrt(2),  1,          0, 0 ], 
                    [  0, -1,          0,  0, -1/sqrt(2), 0 ],
                    [  0,  0,          0,  0,  1/sqrt(2), 0 ],
                    [  0,  0,          0,  0,  1/sqrt(2), 1 ],
                    [  0,  0,          0, -1,  1/sqrt(2), 0 ] ], dtype=float )
b_orig = asarray( [ 0, 18, 0, 12, 0, 0 ], dtype=float ) 
x = b_orig.copy()
gaussPivot(A_orig.copy(),x)
print "Solution= ", x
assert np.linalg.norm( dot(A_orig,x) - b_orig ) < 1.e-9
