#!/usr/bin/env python
#
# Problem EPage 62
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, dot, sqrt

from gaussPivot import gaussPivot

A_orig = asarray( [ [ 80, -50, -30, 0 ], 
                    [ -50, 100, -10, -25 ], 
                    [ -30, -10, 65, -20 ], 
                    [ 0, -25, -20, 100 ] ], dtype=float )
b_orig = asarray( [ -240, 0, 0, 0 ], dtype=float ) 
x = b_orig.copy()
gaussPivot(A_orig.copy(),x)
print "Solution= ", x
assert np.linalg.norm( dot(A_orig,x) - b_orig ) < 1.e-9
