#!/usr/bin/env python
#
# Problem EPage 173
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import linspace
from bisection import *
from newtonRaphson import *

def f(x): return x**4 + 2 * x**3 - 7 * x**2 + 3
def df(x): return 4 * x**3 + 6 * x**2 - 14 * x

if __name__ == "__main__":
    if True:
        xs = linspace( -1.0, +3.0, 300 )
        fs = [ f(_) for _ in xs ]
    
        import pylab; 
        pylab.plot( xs, fs ); 
        pylab.axhline(y=0,color='k')
        pylab.axvline(x=0,color='k')
        pylab.xlabel('x'); pylab.ylabel('f(x)');
        pylab.grid('on'); 
        pylab.show()

    print "Leftmost root= ", newtonRaphson( f, df, 0.5, 1.0 )
    print "Rightmost root= ", newtonRaphson( f, df, 1.5, 2 ) 

    


