#!/usr/bin/env python
#
# Problem EPage 173
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import linspace, sin, cos 
from bisection import *
from newtonRaphson import *

def f(x): return sin(x) - 0.1 * x 
def df(x): return cos(x) - 0.1 

if __name__ == "__main__":
    if True:
        xs = linspace( 0.0, +20.0, 500 )
        fs = [ f(_) for _ in xs ]
    
        import pylab; 
        pylab.plot( xs, fs ); 
        pylab.axhline(y=0,color='k')
        pylab.xlabel('x'); pylab.ylabel('f(x)');
        pylab.grid('on'); 
        pylab.show()

    print "First root= ", newtonRaphson( f, df, 1.5, 5 )
    print "Second root= ", newtonRaphson( f, df, 6, 7.5 ) 
    print "Third root= ", newtonRaphson( f, df, 7.5, 10 ) 

    


