#!/usr/bin/env python
#
# Problem EPage 176
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import linspace, nan
from newtonRaphson import *

def f(xi): return xi * ( (3. - 2. * xi)**2 / (1 - xi)**3 ) - 249.2 
def df(xi): return ( (3. - 2. * xi)**2 / (1 - xi)**3 ) - 4 * xi * ( (3. - 2. * xi) / (1 - xi)**3 ) + 3 * xi * ( (3. - 2. * xi)**2 / (1 - xi)**4 )

if __name__ == "__main__":

    if True: 
        xs = linspace( 0.6, 0.95, 500 )
        fs = [ f(_) for _ in xs ]
    
        import pylab; 
        pylab.plot( xs, fs ); 
        pylab.xlabel('x'); pylab.ylabel('f(x)');
        pylab.hold('on')
        pylab.axhline(y=0,color='k')
        pylab.grid('on'); 
        pylab.show()

    xi = newtonRaphson( f, df, 0.8, 0.9 )
    print "xi= ", xi
