#!/usr/bin/env python
#
# Problem EPage 239
# Table of Gauss-Legendre points on EPage 230
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import sin, pi
from gaussQuad import *

def f(x): return x * sin(x)

a = 0
b = pi 
nNodes = 3
I = gaussQuad( f, a, b, nNodes )
I_exact = pi
print "Gauss-Legendre (%3d nodes); I= %10.6f, true error= %10.6f" % (nNodes,I,I_exact-I)




 
