#!/usr/bin/env python
#
# Problem EPage 362
# Following steps on EPage 355 from the book
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, dot

from jacobi import jacobi 
from sortJacobi import sortJacobi 
from powerMethod import powerMethod 

A = asarray( [ [ 4, -2, 1, -1 ], [ -2, 4, -2, 1 ], [ 1, -2, 4, -2 ], [ -1, 1, -2, 4 ] ], dtype=float ) 

Lam, X = jacobi(A.copy())
sortJacobi(Lam,X)
print "eigenvalues (jacobi)= ", Lam
print "eigenvectors (jacobi)= "
print X
if False:
    print "Checking Ax = lambda x for our solution"
    print "A x= "
    print dot(A,X) 
    print "lambda x= "
    print np.tile( Lam, (A.shape[0],1) ) * X 

Lam, X = powerMethod(A)
print "largest eigenvalue (powerMethod)= ", Lam
print "corresponding eigenvector (powerMethod)= "
print X
