#!/usr/bin/env python
#
# Problem EPage 362
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, sqrt, diag, dot

from jacobi import jacobi 
from sortJacobi import sortJacobi 

A = asarray( [ [ 11, 2, 3, 1, 4, 2 ], [ 2, 9, 3, 5, 2, 1 ], [ 3, 3, 15, 4, 3, 2 ], 
               [ 1, 5, 4, 12, 4, 3 ], [ 4, 2, 3, 4, 17, 5 ], [ 2, 1, 2, 3, 5, 8 ] ], dtype=float ) 

Lam, X = jacobi(A.copy())
sortJacobi(Lam,X) # arrange in ascending order
print "eigenvalues= ", Lam
print "eigenvectors= "
print X

if False:
    print "Checking A x = lambda x for our solution"
    print "A x= "
    print dot(A,X) 
    print "lambda x= "
    print np.tile( Lam, (A.shape[0],1) ) * X
    print np.linalg.norm( ( dot(A,X) - np.tile( Lam, (A.shape[0],1) ) * X ).flatten() )




