#!/usr/bin/env python
#
# Problem EPage 221
# Example of this on EPage 216
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import sqrt, pi, sin
from romberg import romberg

def f(x): 
    theta0_rad = theta0 * ( pi / 180 ) 
    return 1. / sqrt( 1 - sin(theta0_rad/2)**2 * sin(x)**2 )

theta0s = [0,15,30,45]

Is = []
for theta0 in theta0s: 
    romb = romberg(f,0,pi/2)
    Is.append(romb[0])

truth = pi/2.

print "pi/2= ", truth
print "theta0 values= ", theta0s
print "h(theta0)= ", Is


