#!/usr/bin/env python
#
# Problem EPage 221
# Example of this on EPage 216
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import linspace, sqrt, asarray

nPanels = 10
xs = linspace( 0, 0.5, nPanels+1 )
Fs = asarray( [ 0, 37, 71, 104, 134, 161, 185, 207, 225, 239, 250 ] ).astype(float) 

I = 0.
for ii in range(1,nPanels+1): 
    I += 0.5 * ( xs[ii] - xs[ii-1] ) * ( Fs[ii-1] + Fs[ii] )
print "I= ", I 

# derive the velocity from the integral: 
m = 0.075
v2 = (2./m) * I 
print "v = ", sqrt(v2) 
