#!/usr/bin/env python
#
# Problem EPage 276
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import sin, asarray, zeros, argsort 
from run_kut4 import integrate
from printSoln import printSoln
import pylab 

def F(x,y): 
    F = zeros( (2,), dtype=float ) 
    F[0] = y[1]
    F[1] = -sin(y[0])
    return F

x0 = 0.0 # start of the integration 
xStop = 10.0 # end of the integration 
y0 = asarray( [ 1., 0. ], dtype=float ) 
h = 0.05 
freq = 20 

X,Y = integrate(F,x0,y0,xStop,h) 
#printSoln(X,Y,freq)

if False:
    pylab.plot( X, Y[:,0] )
    pylab.xlabel('time (t)'); pylab.ylabel('theta(t)');
    pylab.grid('on')
    pylab.show() 



