#!/usr/bin/env python
#
# Problem EPage 299
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, zeros
from run_kut5 import integrate
from printSoln import printSoln
import pylab 

def F(x,y): 
    # vector y is = [ y(t) ] 
    F = zeros( (1,), dtype=float ) 
    F[0] = ( 9. / y[0] - y[0] ) * x
    return F 

x0 = 0.0 # start of the integration 
xStop = 4.0 # end of the integration 
h = 0.05
freq = 0

y0 = asarray( [ 5 ], dtype=float ) 
X,Y = integrate(F,x0,y0,xStop,h) 
printSoln(X,Y,freq)

if True: 
    pylab.plot( X, Y[:,0] )
    pylab.xlabel('x'); pylab.ylabel('y(x)')
    pylab.grid('on')
    pylab.show() 
