#!/usr/bin/env python
#
# Problem EPage 299
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, zeros, sin, cos, pi 
from run_kut5 import integrate
from printSoln import printSoln
import pylab 

def F(x,y): 
    # vector y is = [ y(t), y'(t) ]
    F = zeros( (2,), dtype=float ) 
    F[0] = y[1]
    F[1] = -1001 * y[1] - 1000 * y[0]
    return F 

x0 = 0.0 # start of the integration 
xStop = 0.2 # end of the integration 
h = 0.05
freq = 0

y0 = asarray( [ 1., 0. ], dtype=float ) 
X,Y = integrate(F,x0,y0,xStop,h) 
printSoln(X,Y,freq)

if True: 
    pylab.plot( X, Y[:,1] )
    pylab.xlabel('x'); pylab.ylabel("y'(x)")
    pylab.grid('on')
    pylab.show() 
