#!/usr/bin/env python
#
# Problem EPage 362
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, sqrt, diag, dot, zeros, identity

from stdForm import stdForm
from jacobi import jacobi
from sortJacobi import sortJacobi

A = asarray( [ [ 3, -2, 0, 0 ], [ -2, 5, -3, 0 ], [ 0, -3, 7, -4 ], [ 0, 0, -4, 9 ] ], dtype=float ) 

Lam, X = jacobi(A.copy())
sortJacobi(Lam,X) # arrange in ascending order
print "eigenvalues= ", Lam
print "eigenvectors= "
print X

if False:
    print "Checking Ax = lambda x for our solution"
    print "A x= "
    AX = dot(A,X) 
    print AX
    print "lambda x= "
    LX = np.tile( Lam, (X.shape[0],1) ) * X
    print LX
    print "||A X - lambda X||= ", np.linalg.norm( ( AX - LX ).flatten() )
