#!/usr/bin/env python
#
# Problem EPage 
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import dot, diagonal

from householder import householder, computeP
from eigenvals3 import eigenvals3
import scipy.linalg ; from scipy.linalg import hilbert

n = 6

A_orig = hilbert(n)
A = A_orig.copy()

d, c = householder( A ) 
print "diagonal d= "
print d
print "subdiagonal c= "
print c
print "transformation matrix P="
P = computeP(A)
print P

smallest_two_evalues = eigenvals3(d,c,2)
print "smallest_two_evalues= ", smallest_two_evalues

if False:
    print "Verify that we can transform A into the tridiagonal form given above using P: "
    M = dot(dot(P.T,A_orig),P)
    print diagonal( M, offset=0 ) 
    print diagonal( M, offset=1 )     
    print diagonal( M, offset=-1 ) 



